Attribute VB_Name = "Module1"
Option Explicit
Public PictureLoaded As Boolean
Public PictureRendered As Boolean
Public TilesWide As Long, TilesHigh As Long, TileWidth As Long, TileHeight As Long
Public TopGap As Integer
Public BrightnessLevel As Integer
Public BackColor As Long
Public X2 As Long, Y2 As Long, X3 As Long, Y3 As Long, Counter As Long
Public Const PROGUNIT = 49.95


Sub Main()
    frmSplash.Show
    frmSplash.Refresh
    Sleep 2000
    Unload frmSplash
    frmMain.Show
End Sub


Sub RotateFloor()
    Dim AddOn As Double, ValueOn As Double
    frmMain.pic2.Cls
    frmMain.pic3.Cls
    frmMain.PictureFinal.Width = (TilesWide * (TileWidth + TileHeight))
    frmMain.PictureFinal.Height = (TilesHigh * (((TileWidth + TileHeight) / 2) + TopGap))
    frmMain.PictureFinal.BackColor = BackColor
    If frmMain.PictureFinal.Height > frmMain.picFinalFrame.ScaleHeight Then
        frmMain.VScroll2.Min = 0
        frmMain.VScroll2.Max = frmMain.PictureFinal.Height - frmMain.picFinalFrame.ScaleHeight
        frmMain.VScroll2.Value = 0
        frmMain.VScroll2.Enabled = True
    Else
        frmMain.VScroll2.Enabled = False
    End If
    If frmMain.PictureFinal.Width > frmMain.picFinalFrame.ScaleWidth Then
        frmMain.HScroll2.Min = 0
        frmMain.HScroll2.Max = frmMain.PictureFinal.Width - frmMain.picFinalFrame.ScaleWidth
        frmMain.HScroll2.Value = 0
        frmMain.HScroll2.Enabled = True
    Else
        frmMain.HScroll2.Enabled = False
    End If
    frmMain.pic2.Width = TileWidth + TileHeight
    frmMain.pic2.Height = TileHeight
    frmMain.pic2.BackColor = BackColor
    frmMain.pic3.Width = TileWidth + TileHeight
    frmMain.pic3.Height = TileHeight + TileWidth
    frmMain.pic3.BackColor = BackColor
    AddOn = 100 / (TilesWide * TilesHigh)
    ValueOn = 0
    frmProgress.lblDescription.Caption = "Rotating Frames to Floor Position...."
    frmProgress.lblProgress = "0%"
    frmProgress.Shape1.Width = 0
    frmProgress.Show 0, frmMain
    frmProgress.Refresh
    DoEvents
    For Y2 = 0 To TilesHigh - 1
        For X2 = 0 To TilesWide - 1
            For Y3 = (Y2 * TileHeight) To ((Y2 + 1) * TileHeight) - 1
                For X3 = (X2 * TileWidth) To ((X2 + 1) * TileWidth) - 1
                    SetPixel frmMain.pic2.hDC, X3 - (X2 * TileWidth) + (TileHeight - (Y3 - (Y2 * TileHeight))) - 1, Y3 - (Y2 * TileHeight), IIf(BrightnessLevel = 0, GetPixel(frmMain.Picture1.hDC, X3, Y3), AdjustBrightness(GetPixel(frmMain.Picture1.hDC, X3, Y3)))
                Next X3
            Next Y3
            frmMain.pic2.Refresh
            Counter = 0
            For X3 = 0 To (TileWidth + TileHeight) - 1
                If X3 Mod 2 = 1 Then Counter = Counter + 1
                For Y3 = 0 To TileHeight - 1
                    SetPixel frmMain.pic3.hDC, X3, Y3 + Counter, GetPixel(frmMain.pic2.hDC, X3, Y3)
                Next Y3
            Next X3
            frmMain.pic3.Refresh
            BitBlt frmMain.PictureFinal.hDC, X2 * (TileWidth + TileHeight), Y2 * ((TileWidth + TileHeight) / 2) + ((Y2 + 1) * TopGap), TileWidth + TileHeight, TileHeight + (TileHeight / 2), frmMain.pic3.hDC, 0, TileHeight / 2, vbSrcCopy
            frmMain.PictureFinal.Refresh
            frmMain.pic2.Cls
            frmMain.pic3.Cls
            ValueOn = ValueOn + AddOn
            If ValueOn > 100 Then ValueOn = 100
            frmProgress.lblProgress.Caption = Trim(Str(CInt(ValueOn))) & "%"
            frmProgress.Shape1.Width = CInt(PROGUNIT * ValueOn)
        Next X2
    Next Y2
    frmMain.PictureFinal.Refresh
    Unload frmProgress
    PictureRendered = True
End Sub
Sub RotateWall1()
    Dim AddOn As Double, ValueOn As Double
    frmMain.pic2.Cls
    frmMain.pic3.Cls
    frmMain.PictureFinal.Width = (TilesWide * TileWidth)
    frmMain.PictureFinal.Height = (TilesHigh * ((TileHeight + TileWidth / 2) + TopGap))
    frmMain.PictureFinal.BackColor = BackColor
    If frmMain.PictureFinal.Height > frmMain.picFinalFrame.ScaleHeight Then
        frmMain.VScroll2.Min = 0
        frmMain.VScroll2.Max = frmMain.PictureFinal.Height - frmMain.picFinalFrame.ScaleHeight
        frmMain.VScroll2.Value = 0
        frmMain.VScroll2.Enabled = True
    Else
        frmMain.VScroll2.Enabled = False
    End If
    If frmMain.PictureFinal.Width > frmMain.picFinalFrame.ScaleWidth Then
        frmMain.HScroll2.Min = 0
        frmMain.HScroll2.Max = frmMain.PictureFinal.Width - frmMain.picFinalFrame.ScaleWidth
        frmMain.HScroll2.Value = 0
        frmMain.HScroll2.Enabled = True
    Else
        frmMain.HScroll2.Enabled = False
    End If
    frmMain.pic2.Width = TileWidth
    frmMain.pic2.Height = TileHeight
    frmMain.pic2.BackColor = BackColor
    frmMain.pic3.Width = TileWidth
    frmMain.pic3.Height = TileHeight + (TileWidth / 2)
    frmMain.pic3.BackColor = BackColor
    AddOn = 100 / (TilesWide * TilesHigh)
    ValueOn = 0
    frmProgress.lblDescription.Caption = "Rotating Frames to Right Wall Position...."
    frmProgress.lblProgress = "0%"
    frmProgress.Shape1.Width = 0
    frmProgress.Show 0, frmMain
    frmProgress.Refresh
    DoEvents
    For Y2 = 0 To TilesHigh - 1
        For X2 = 0 To TilesWide - 1
            BitBlt frmMain.pic2.hDC, 0, 0, TileWidth, TileHeight, frmMain.Picture1.hDC, X2 * TileWidth, Y2 * TileHeight, vbSrcCopy
            frmMain.pic2.Refresh
            Counter = 0
            For X3 = 0 To TileWidth - 1
                If X3 Mod 2 = 1 Then Counter = Counter + 1
                For Y3 = 0 To TileHeight - 1
                    SetPixel frmMain.pic3.hDC, X3, Y3 + Counter, IIf(BrightnessLevel = 0, GetPixel(frmMain.pic2.hDC, X3, Y3), AdjustBrightness(GetPixel(frmMain.pic2.hDC, X3, Y3)))
                Next Y3
            Next X3
'                For X3 = 0 To TileWidth - 1
'                    If X3 Mod 2 = 0 Then Counter = Counter + 1
'                    For Y3 = 0 To TileHeight - 1
'                        SetPixel pic3.hDC, X3, Y3 + ((TileWidth / 2) - Counter), IIf(BrightnessLevel = 0, GetPixel(pic2.hDC, X3, Y3), AdjustBrightness(GetPixel(pic2.hDC, X3, Y3)))
'                    Next Y3
'                Next X3
            frmMain.pic3.Refresh
            'BitBlt frmMain.PictureFinal.hDC, X2 * (TileWidth + TileHeight), Y2 * (TileHeight + (TileHeight / 2)) + ((Y2 + 1) * TopGap), TileWidth + TileHeight, TileHeight + (TileHeight / 2), frmMain.pic3.hDC, 0, TileHeight / 2, vbSrcCopy
            BitBlt frmMain.PictureFinal.hDC, X2 * TileWidth, Y2 * (TileHeight + (TileWidth / 2)) + ((Y2 + 1) * TopGap), TileWidth, TileHeight + (TileWidth / 2), frmMain.pic3.hDC, 0, 0, vbSrcCopy
            frmMain.PictureFinal.Refresh
            frmMain.pic2.Cls
            frmMain.pic3.Cls
            ValueOn = ValueOn + AddOn
            If ValueOn > 100 Then ValueOn = 100
            frmProgress.lblProgress.Caption = Trim(Str(CInt(ValueOn))) & "%"
            frmProgress.Shape1.Width = CInt(PROGUNIT * ValueOn)
        Next X2
    Next Y2
    frmMain.PictureFinal.Refresh
    Unload frmProgress
    PictureRendered = True
End Sub
Sub RotateWall2()
    Dim AddOn As Double, ValueOn As Double
    frmMain.pic2.Cls
    frmMain.pic3.Cls
    frmMain.PictureFinal.Width = (TilesWide * TileWidth)
    frmMain.PictureFinal.Height = (TilesHigh * ((TileHeight + TileWidth / 2) + TopGap))
    frmMain.PictureFinal.BackColor = BackColor
    If frmMain.PictureFinal.Height > frmMain.picFinalFrame.ScaleHeight Then
        frmMain.VScroll2.Min = 0
        frmMain.VScroll2.Max = frmMain.PictureFinal.Height - frmMain.picFinalFrame.ScaleHeight
        frmMain.VScroll2.Value = 0
        frmMain.VScroll2.Enabled = True
    Else
        frmMain.VScroll2.Enabled = False
    End If
    If frmMain.PictureFinal.Width > frmMain.picFinalFrame.ScaleWidth Then
        frmMain.HScroll2.Min = 0
        frmMain.HScroll2.Max = frmMain.PictureFinal.Width - frmMain.picFinalFrame.ScaleWidth
        frmMain.HScroll2.Value = 0
        frmMain.HScroll2.Enabled = True
    Else
        frmMain.HScroll2.Enabled = False
    End If
    frmMain.pic2.Width = TileWidth
    frmMain.pic2.Height = TileHeight
    frmMain.pic2.BackColor = BackColor
    frmMain.pic3.Width = TileWidth
    frmMain.pic3.Height = TileHeight + (TileWidth / 2)
    frmMain.pic3.BackColor = BackColor
    AddOn = 100 / (TilesWide * TilesHigh)
    ValueOn = 0
    frmProgress.lblDescription.Caption = "Rotating Frames to Left Wall Position...."
    frmProgress.lblProgress = "0%"
    frmProgress.Shape1.Width = 0
    frmProgress.Show 0, frmMain
    frmProgress.Refresh
    DoEvents
    For Y2 = 0 To TilesHigh - 1
        For X2 = 0 To TilesWide - 1
            BitBlt frmMain.pic2.hDC, 0, 0, TileWidth, TileHeight, frmMain.Picture1.hDC, X2 * TileWidth, Y2 * TileHeight, vbSrcCopy
            frmMain.pic2.Refresh
            Counter = 0
                For X3 = 0 To TileWidth - 1
                    If X3 Mod 2 = 0 Then Counter = Counter + 1
                    For Y3 = 0 To TileHeight - 1
                        SetPixel frmMain.pic3.hDC, X3, Y3 + ((TileWidth / 2) - Counter), IIf(BrightnessLevel = 0, GetPixel(frmMain.pic2.hDC, X3, Y3), AdjustBrightness(GetPixel(frmMain.pic2.hDC, X3, Y3)))
                    Next Y3
                Next X3
            frmMain.pic3.Refresh
            'BitBlt frmMain.PictureFinal.hDC, X2 * (TileWidth + TileHeight), Y2 * (TileHeight + (TileHeight / 2)) + ((Y2 + 1) * TopGap), TileWidth + TileHeight, TileHeight + (TileHeight / 2), frmMain.pic3.hDC, 0, TileHeight / 2, vbSrcCopy
            BitBlt frmMain.PictureFinal.hDC, X2 * TileWidth, Y2 * (TileHeight + (TileWidth / 2)) + ((Y2 + 1) * TopGap), TileWidth, TileHeight + (TileWidth / 2), frmMain.pic3.hDC, 0, 0, vbSrcCopy
            frmMain.PictureFinal.Refresh
            frmMain.pic2.Cls
            frmMain.pic3.Cls
            ValueOn = ValueOn + AddOn
            If ValueOn > 100 Then ValueOn = 100
            frmProgress.lblProgress.Caption = Trim(Str(CInt(ValueOn))) & "%"
            frmProgress.Shape1.Width = CInt(PROGUNIT * ValueOn)
        Next X2
    Next Y2
    frmMain.PictureFinal.Refresh
    Unload frmProgress
    PictureRendered = True
End Sub
Function AdjustBrightness(pPixel As Long) As Long
Dim Red As Integer, Green As Integer, Blue As Integer
    Red = pPixel Mod 256
    Green = (pPixel / 256) Mod 256
    Blue = pPixel / 65536
    Red = Red + BrightnessLevel
    Green = Green + BrightnessLevel
    Blue = Blue + BrightnessLevel
    If Red > 255 Then Red = 255
    If Red < 0 Then Red = 0
    If Green > 255 Then Green = 255
    If Green < 0 Then Green = 0
    If Blue > 255 Then Blue = 255
    If Blue < 0 Then Blue = 0
    AdjustBrightness = RGB(Red, Green, Blue)
End Function
